/* 
   -----------------------------------------------------------------------------
   Este programa halla la inversa de una matriz a travez del algoritmo de Jubete
   -----------------------------------------------------------------------------
*/

#include "jubete.h"

int main(int argc, char *argv[])
{
   int n, m, op;
   double *v;
   PMatrizJubete A, C;

   srand(time(0));
   
   do {
           system("CLS");
           printf("La inversa de una matriz a travez del algoritmo de Jubete\n");
           printf("1) Matriz Castillo (transparencia)\n");
           printf("2) Matriz Aleatoria (random)\n");
           printf("0) Sair\n\n");
           printf("Informe a opcao: "); scanf("%d", &op);
           
           switch(op) {
           case 1 : {
                    A = crearMatriz(5, 5);
                    printf("\nLa matriz:\n");
                    v = getMY(A, 0); v[0] = 1; v[1] = 1; v[2] = 0; v[3] = 1; v[4] = 0;
                    v = getMY(A, 1); v[0] = 0; v[1] = 1; v[2] = 0; v[3] = 1; v[4] = 0;
                    v = getMY(A, 2); v[0] = 0; v[1] = 0; v[2] = -1; v[3] = 1; v[4] = 1;
                    v = getMY(A, 3); v[0] = -1; v[1] = 2; v[2] = 1; v[3] = 0; v[4] = 0;
                    v = getMY(A, 4); v[0] = 1; v[1] = 1; v[2] = 0; v[3] = 1; v[4] = 1;
                    muestraMatriz(A);
                    
                    printf("\nLa inversa:\n");
                    C = invJubete(A);
                    if(C) muestraMatriz(C);
                    else printf("\nNo puede hallarse la inversa de esta matriz\n\n");
                    
                    destruirMatriz(A);
                    destruirMatriz(C);
                    system("PAUSE");	
                } break;
                
           case 2 : {
                   printf("n, m = "); scanf("%d", &n);
                   
                   if(n > 0) {
                        m = n;
                        A = crearMatriz(n, m);
                        printf("\nLa matriz:\n");
                        poblarMatriz(A);
                        muestraMatriz(A);
                        
                        printf("\nLa inversa:\n");
                        C = invJubete(A);
                        if(C) muestraMatriz(C);
                        else printf("\nNo puede hallarse la inversa de esta matriz\n\n");
                        
                        destruirMatriz(A);
                        destruirMatriz(C);
                   } else printf("\nTamao no vlido\n\n");
                   
                   system("PAUSE");	
                } break;
           }
   } while(op > 0);
   
   return 0;
}

