#ifndef _JUBETE_
#define _JUBETE_

      #include <stdio.h>
      #include <stdlib.h>
      #include <math.h>
      #include <time.h>

      typedef struct {
             int n, m;
             double *M;
      } TMatrizJubete;
      
      typedef TMatrizJubete* PMatrizJubete;

      PMatrizJubete crearMatriz(int n, int m);
      PMatrizJubete crearMatrizIdentidad(int n, int m);
      double getM(PMatrizJubete A, int x, int y);
      double * getMY(PMatrizJubete A, int y);
      void setM(PMatrizJubete A, int x, int y, double value);
      void setMY(PMatrizJubete A, int y, double *value[]);
      void poblarMatriz(PMatrizJubete A);
      void muestraMatriz(PMatrizJubete A);
      void destruirMatriz(PMatrizJubete A);
      PMatrizJubete invJubete(PMatrizJubete A);

#endif
